diff a/src/hotspot/share/runtime/java.cpp b/src/hotspot/share/runtime/java.cpp
--- a/src/hotspot/share/runtime/java.cpp
+++ b/src/hotspot/share/runtime/java.cpp
@@ -21,26 +21,33 @@
  * questions.
  *
  */
 
 #include "precompiled.hpp"
+#include "cds/aotLinkedClassBulkLoader.hpp"
 #include "cds/cds_globals.hpp"
+#include "cds/cdsConfig.hpp"
 #include "cds/classListWriter.hpp"
 #include "cds/dynamicArchive.hpp"
+#include "cds/methodProfiler.hpp"
+#include "cds/metaspaceShared.hpp"
 #include "classfile/classLoader.hpp"
 #include "classfile/classLoaderDataGraph.hpp"
 #include "classfile/javaClasses.hpp"
 #include "classfile/stringTable.hpp"
 #include "classfile/symbolTable.hpp"
 #include "classfile/systemDictionary.hpp"
 #include "code/codeCache.hpp"
+#include "code/SCCache.hpp"
 #include "compiler/compilationMemoryStatistic.hpp"
+#include "compiler/compilationPolicy.hpp"
 #include "compiler/compileBroker.hpp"
 #include "compiler/compilerOracle.hpp"
 #include "gc/shared/collectedHeap.hpp"
 #include "gc/shared/stringdedup/stringDedup.hpp"
 #include "interpreter/bytecodeHistogram.hpp"
+#include "interpreter/interpreterRuntime.hpp"
 #include "jfr/jfrEvents.hpp"
 #include "jfr/support/jfrThreadId.hpp"
 #include "jvm.h"
 #include "logging/log.hpp"
 #include "logging/logStream.hpp"
@@ -57,15 +64,18 @@
 #include "oops/klassVtable.hpp"
 #include "oops/method.hpp"
 #include "oops/objArrayOop.hpp"
 #include "oops/oop.inline.hpp"
 #include "oops/symbol.hpp"
+#include "oops/trainingData.hpp"
 #include "prims/jvmtiAgentList.hpp"
 #include "prims/jvmtiExport.hpp"
+#include "prims/methodHandles.hpp"
 #include "runtime/continuation.hpp"
 #include "runtime/deoptimization.hpp"
 #include "runtime/flags/flagSetting.hpp"
+#include "runtime/globals_extension.hpp"
 #include "runtime/handles.inline.hpp"
 #include "runtime/init.hpp"
 #include "runtime/interfaceSupport.inline.hpp"
 #include "runtime/java.hpp"
 #include "runtime/javaThread.hpp"
@@ -157,10 +167,92 @@
       tty->print_cr("Total MDO size: %d bytes", total_size);
     }
   }
 }
 
+void perf_jvm_print_on(outputStream* st);
+
+void log_vm_init_stats() {
+  LogStreamHandle(Info, init) log;
+  if (log.is_enabled()) {
+    SharedRuntime::print_counters_on(&log);
+    ClassLoader::print_counters(&log);
+    AOTLinkedClassBulkLoader::print_counters_on(&log);
+    log.cr();
+    // FIXME: intermittent crashes
+//    if (CountBytecodesPerThread) {
+//      log.print_cr("Thread info:");
+//      class PrintThreadInfo : public ThreadClosure {
+//        outputStream* _st;
+//      public:
+//        PrintThreadInfo(outputStream* st) : ThreadClosure(), _st(st) {}
+//        void do_thread(Thread* thread) {
+//          JavaThread* jt = JavaThread::cast(thread);
+//          if (jt->bc_counter_value() > 0) {
+//            _st->print_cr("  Thread " INTPTR_FORMAT ": %ld bytecodes executed (clinit: %ld)",
+//                          p2i(jt), /*jt->name(),*/ jt->bc_counter_value(), jt->clinit_bc_counter_value());
+//          }
+//        }
+//      };
+//      PrintThreadInfo cl(&log);
+//      Threads::java_threads_do(&cl);
+//    }
+//    log.cr();
+    log.print_cr("Deoptimization events: ");
+    Deoptimization::print_statistics_on(&log);
+    log.cr();
+
+    log.print("Compilation statistics: ");
+    CompileBroker::print_statistics_on(&log);
+    log.cr();
+
+    {
+      MutexLocker mu(CodeCache_lock, Mutex::_no_safepoint_check_flag);
+      log.print("Code cache statistics: ");
+      CodeCache::print_nmethod_statistics_on(&log);
+      log.cr();
+    }
+
+    if (SCCache::is_on_for_read()) {
+      log.print_cr("Startup Code Cache: ");
+      SCCache::print_statistics_on(&log);
+      log.cr();
+      SCCache::print_timers_on(&log);
+    }
+
+    VMThread::print_counters_on(&log);
+    log.cr();
+    MutexLockerImpl::print_counters_on(&log);
+    log.cr();
+    log.print("Runtime events for thread \"main\"");
+    if (ProfileRuntimeCalls) {
+      log.print_cr(" (%d nested events):", ProfileVMCallContext::nested_runtime_calls_count());
+
+      InterpreterRuntime::print_counters_on(&log);
+#ifdef COMPILER1
+      Runtime1::print_counters_on(&log);
+#endif
+#ifdef COMPILER2
+      OptoRuntime::print_counters_on(&log);
+      Deoptimization::print_counters_on(&log);
+#endif
+    } else {
+      log.print_cr(": no info (%s is disabled)", (UsePerfData ? "ProfileRuntimeCalls" : "UsePerfData"));
+    }
+    log.cr();
+    perf_jvm_print_on(&log);
+    log.cr();
+    MethodHandles::print_counters_on(&log);
+  }
+}
+
+void print_bytecode_count() {
+  if (CountBytecodes || TraceBytecodes || StopInterpreterAt) {
+    tty->print_cr("[BytecodeCounter::counter_value = " JLONG_FORMAT "]", BytecodeCounter::counter_value());
+  }
+}
+
 #ifndef PRODUCT
 
 // Statistics printing (method invocation histogram)
 
 GrowableArray<Method*>* collected_invoked_methods;
@@ -224,37 +316,35 @@
   tty->print_cr("\t" UINT64_FORMAT_W(12) " (%4.1f%%)    |- final",       final_total,   100.0 * (double)final_total  / total_div);
   tty->print_cr("\t" UINT64_FORMAT_W(12) " (%4.1f%%)    |- static",      static_total,  100.0 * (double)static_total / total_div);
   tty->print_cr("\t" UINT64_FORMAT_W(12) " (%4.1f%%)    |- native",      native_total,  100.0 * (double)native_total / total_div);
   tty->print_cr("\t" UINT64_FORMAT_W(12) " (%4.1f%%)    |- accessor",    access_total,  100.0 * (double)access_total / total_div);
   tty->cr();
-  SharedRuntime::print_call_statistics(comp_total);
-}
-
-static void print_bytecode_count() {
-  if (CountBytecodes || TraceBytecodes || StopInterpreterAt) {
-    tty->print_cr("[BytecodeCounter::counter_value = %d]", BytecodeCounter::counter_value());
-  }
+  SharedRuntime::print_call_statistics_on(tty);
 }
 
 #else
 
 static void print_method_invocation_histogram() {}
-static void print_bytecode_count() {}
 
 #endif // PRODUCT
 
 
 // General statistics printing (profiling ...)
 void print_statistics() {
+#if INCLUDE_CDS
+  if (ReplayTraining && PrintTrainingInfo) {
+    TrainingData::print_archived_training_data_on(tty);
+  }
+#endif
   if (CITime) {
     CompileBroker::print_times();
   }
 
 #ifdef COMPILER1
   if ((PrintC1Statistics || LogVMOutput || LogCompilation) && UseCompiler) {
     FlagSetting fs(DisplayVMOutput, DisplayVMOutput && PrintC1Statistics);
-    Runtime1::print_statistics();
+    Runtime1::print_statistics_on(tty);
     SharedRuntime::print_statistics();
   }
 #endif /* COMPILER1 */
 
 #ifdef COMPILER2
@@ -317,10 +407,16 @@
   // CodeHeap State Analytics.
   if (PrintCodeHeapAnalytics) {
     CompileBroker::print_heapinfo(nullptr, "all", 4096); // details
   }
 
+  LogStreamHandle(Debug, codecache, nmethod) log;
+  if (log.is_enabled()) {
+    MutexLocker mu(CodeCache_lock, Mutex::_no_safepoint_check_flag);
+    CodeCache::print_nmethods_on(&log);
+  }
+
 #ifndef PRODUCT
   if (PrintCodeCache2) {
     MutexLocker mu(CodeCache_lock, Mutex::_no_safepoint_check_flag);
     CodeCache::print_internals();
   }
@@ -357,10 +453,12 @@
     CompilationMemoryStatistic::print_all_by_size(tty, false, 0);
   }
 
   ThreadsSMRSupport::log_statistics();
 
+  log_vm_init_stats();
+
   if (log_is_enabled(Info, perf, class, link)) {
     LogStreamHandle(Info, perf, class, link) log;
     log.print_cr("At VM exit:");
     ClassLoader::print_counters(&log);
   }
@@ -422,29 +520,38 @@
     static_cast<void>(LSAN_DO_RECOVERABLE_LEAK_CHECK());
   }
 #endif
 
 #if INCLUDE_CDS
-  // Dynamic CDS dumping must happen whilst we can still reliably
-  // run Java code.
-  DynamicArchive::dump_at_exit(thread, ArchiveClassesAtExit);
-  assert(!thread->has_pending_exception(), "must be");
+  MethodProfiler::process_method_hotness();
 #endif
 
-
   // Actual shutdown logic begins here.
 
 #if INCLUDE_JVMCI
   if (EnableJVMCI) {
     JVMCI::shutdown(thread);
   }
 #endif
 
 #if INCLUDE_CDS
   ClassListWriter::write_resolved_constants();
+  ClassListWriter::write_reflection_data();
+  ClassListWriter::write_loader_negative_lookup_cache();
+  // Dynamic CDS dumping must happen whilst we can still reliably
+  // run Java code.
+  if (CDSConfig::is_dumping_preimage_static_archive()) {
+    // Creating the hotspot.cds.preimage file
+    MetaspaceShared::preload_and_dump(thread);
+  } else {
+    DynamicArchive::dump_at_exit(thread, ArchiveClassesAtExit);
+  }
+  assert(!thread->has_pending_exception(), "must be");
 #endif
 
+  SCCache::close(); // Write final data and close archive
+
   // Hang forever on exit if we're reporting an error.
   if (ShowMessageBoxOnError && VMError::is_error_reported()) {
     os::infinite_sleep();
   }
 
@@ -481,11 +588,11 @@
       ClassLoaderDataGraph::print_on(&ls_trace);
     }
   }
 
   if (PrintBytecodeHistogram) {
-    BytecodeHistogram::print();
+    BytecodeHistogram::print(PrintBytecodeHistogramCutoff);
   }
 
 #ifdef LINUX
   if (DumpPerfMapAtExit) {
     CodeCache::write_perf_map(nullptr, tty);
@@ -506,10 +613,15 @@
 
   // Terminate the signal thread
   // Note: we don't wait until it actually dies.
   os::terminate_signal_thread();
 
+  if (VerifyTrainingData) {
+    EXCEPTION_MARK;
+    CompilationPolicy::replay_training_at_init(true, THREAD); // implies TrainingData::verify()
+  }
+
   print_statistics();
   Universe::heap()->print_tracing_info();
 
   { MutexLocker ml(BeforeExit_lock);
     _before_exit_status = BEFORE_EXIT_DONE;
diff a/src/hotspot/share/runtime/java.hpp b/src/hotspot/share/runtime/java.hpp
--- a/src/hotspot/share/runtime/java.hpp
+++ b/src/hotspot/share/runtime/java.hpp
@@ -57,10 +57,15 @@
 extern void vm_exit_during_initialization(const char* error, const char* message = nullptr);
 extern void vm_shutdown_during_initialization(const char* error, const char* message = nullptr);
 
 extern void vm_exit_during_cds_dumping(const char* error, const char* message = nullptr);
 
+extern void perf_jvm_print_on(outputStream* st);
+extern void perf_deoptimization_print_on(outputStream* st);
+
+extern void log_vm_init_stats();
+
 // This is defined in linkType.cpp due to linking restraints
 extern bool is_vm_statically_linked();
 
 /**
  * With the integration of the changes to handle the version string
diff a/src/hotspot/share/runtime/javaThread.cpp b/src/hotspot/share/runtime/javaThread.cpp
--- a/src/hotspot/share/runtime/javaThread.cpp
+++ b/src/hotspot/share/runtime/javaThread.cpp
@@ -495,10 +495,12 @@
   _cont_fastpath_thread_state(1),
   _held_monitor_count(0),
   _jni_monitor_count(0),
   _unlocked_inflated_monitor(nullptr),
 
+  _can_call_java(true),
+
   _preempt_alternate_return(nullptr),
   _preemption_cancelled(false),
   _pending_interrupted_exception(false),
 
   _handshake(this),
@@ -976,11 +978,11 @@
   }
 
   // We need to cache the thread name for logging purposes below as once
   // we have called on_thread_detach this thread must not access any oops.
   char* thread_name = nullptr;
-  if (log_is_enabled(Debug, os, thread, timer)) {
+  if (log_is_enabled(Debug, os, thread, timer) || (CountBytecodesPerThread && log_is_enabled(Info, init))) {
     ResourceMark rm(this);
     thread_name = os::strdup(name());
   }
 
   if (log_is_enabled(Info, os, thread)) {
@@ -1003,10 +1005,15 @@
       }
     }
   }
 #endif // INCLUDE_JVMCI
 
+  if (bc_counter_value() > 0) {
+    log_info(init)("Thread '%s': " JLONG_FORMAT " bytecodes executed (during clinit: " JLONG_FORMAT ")",
+                   thread_name, bc_counter_value(), clinit_bc_counter_value());
+  }
+
   // Remove from list of active threads list, and notify VM thread if we are the last non-daemon thread.
   // We call BarrierSet::barrier_set()->on_thread_detach() here so no touching of oops after this point.
   Threads::remove(this, daemon);
 
   if (log_is_enabled(Debug, os, thread, timer)) {
@@ -1761,30 +1768,35 @@
 // This is the external format, selecting the platform or vthread
 // as applicable, and allowing for a native-only stack.
 void JavaThread::print_jni_stack() {
   assert(this == JavaThread::current(), "Can't print stack of other threads");
   if (!has_last_Java_frame()) {
-    ResourceMark rm(this);
-    char* buf = NEW_RESOURCE_ARRAY_RETURN_NULL(char, O_BUFLEN);
-    if (buf == nullptr) {
-      tty->print_cr("Unable to print native stack - out of memory");
-      return;
-    }
-    address lastpc = nullptr;
-    if (os::platform_print_native_stack(tty, nullptr, buf, O_BUFLEN, lastpc)) {
-      // We have printed the native stack in platform-specific code,
-      // so nothing else to do in this case.
-    } else {
-      frame f = os::current_frame();
-      VMError::print_native_stack(tty, f, this, true /*print_source_info */,
-                                  -1 /* max stack */, buf, O_BUFLEN);
-    }
+    print_native_stack_on(tty);
   } else {
     print_active_stack_on(tty);
   }
 }
 
+void JavaThread::print_native_stack_on(outputStream *st) {
+  assert(this == JavaThread::current(), "Can't print stack of other threads");
+  ResourceMark rm;
+  char* buf = NEW_RESOURCE_ARRAY_RETURN_NULL(char, O_BUFLEN);
+  if (buf == nullptr) {
+    st->print_cr("Unable to print native stack - out of memory");
+    return;
+  }
+  address lastpc = nullptr;
+  if (os::platform_print_native_stack(st, nullptr, buf, O_BUFLEN, lastpc)) {
+    // We have printed the native stack in platform-specific code,
+    // so nothing else to do in this case.
+  } else {
+    frame f = os::current_frame();
+    VMError::print_native_stack(st, f, this, true /*print_source_info */,
+                                -1 /* max stack */, buf, O_BUFLEN);
+  }
+}
+
 void JavaThread::print_stack_on(outputStream* st) {
   if (!has_last_Java_frame()) return;
 
   Thread* current_thread = Thread::current();
   ResourceMark rm(current_thread);
@@ -2359,6 +2371,6 @@
     event->set_blockingOperation(op);
     event->set_carrierThread(JFR_JVM_THREAD_ID(this));
     event->commit();
   }
 }
-#endif
+#endif
diff a/src/hotspot/share/runtime/javaThread.hpp b/src/hotspot/share/runtime/javaThread.hpp
--- a/src/hotspot/share/runtime/javaThread.hpp
+++ b/src/hotspot/share/runtime/javaThread.hpp
@@ -478,10 +478,12 @@
   // It's signed for error detection.
   intx _held_monitor_count;  // used by continuations for fast lock detection
   intx _jni_monitor_count;
   ObjectMonitor* _unlocked_inflated_monitor;
 
+  bool _can_call_java;
+
   // This is the field we poke in the interpreter and native
   // wrapper (Object.wait) to check for preemption.
   address _preempt_alternate_return;
   // When preempting on monitorenter we could have acquired the
   // monitor after freezing all vthread frames. In that case we
@@ -552,13 +554,26 @@
   };
   void exit(bool destroy_vm, ExitType exit_type = normal_exit);
 
   void cleanup_failed_attach_current_thread(bool is_daemon);
 
+  class NoJavaCodeMark : public StackObj {
+    friend JavaThread;
+    JavaThread* _target;
+    bool _orig;
+   public:
+    NoJavaCodeMark(JavaThread* t) : _target(t), _orig(t->_can_call_java) {
+      _target->_can_call_java = false;
+    }
+    ~NoJavaCodeMark() {
+      _target->_can_call_java = _orig;
+    }
+  };
+
   // Testers
   virtual bool is_Java_thread() const            { return true;  }
-  virtual bool can_call_java() const             { return true; }
+  virtual bool can_call_java() const             { return _can_call_java; }
 
   virtual bool is_active_Java_thread() const;
 
   // Thread oop. threadObj() can be null for initial JavaThread
   // (or for threads attached via JNI)
@@ -1027,10 +1042,12 @@
   // Print current stack trace for checked JNI warnings and JNI fatal errors.
   // This is the external format from above, but selecting the platform
   // or vthread as applicable.
   void print_jni_stack();
 
+  void print_native_stack_on(outputStream* st);
+
   // Print stack traces in various internal formats
   void trace_stack()                             PRODUCT_RETURN;
   void trace_stack_from(vframe* start_vf)        PRODUCT_RETURN;
   void trace_frames()                            PRODUCT_RETURN;
 
@@ -1209,12 +1226,13 @@
   // Track the class we want to initialize but for which we have to wait
   // on its init_lock() because it is already being initialized.
   void set_class_to_be_initialized(InstanceKlass* k);
   InstanceKlass* class_to_be_initialized() const;
 
-  // Track executing class initializer, see ThreadInClassInitializer
-  void set_class_being_initialized(InstanceKlass* k);
+  // The most recent active <clinit> invocation is tracked by this variable.
+  // The setter returns the previous value, so it can be restored later if needed.
+  InstanceKlass* set_class_being_initialized(InstanceKlass* k);
   InstanceKlass* class_being_initialized() const;
 
 private:
   InstanceKlass* _class_to_be_initialized;
   InstanceKlass* _class_being_initialized;
diff a/src/hotspot/share/runtime/javaThread.inline.hpp b/src/hotspot/share/runtime/javaThread.inline.hpp
--- a/src/hotspot/share/runtime/javaThread.inline.hpp
+++ b/src/hotspot/share/runtime/javaThread.inline.hpp
@@ -239,17 +239,19 @@
 
 inline InstanceKlass* JavaThread::class_to_be_initialized() const {
   return _class_to_be_initialized;
 }
 
-inline void JavaThread::set_class_being_initialized(InstanceKlass* k) {
-  assert(k != nullptr || _class_being_initialized != nullptr, "incorrect usage");
+inline InstanceKlass* JavaThread::set_class_being_initialized(InstanceKlass* k) {
   assert(this == Thread::current(), "Only the current thread can set this field");
+  InstanceKlass* prev = _class_being_initialized;
   _class_being_initialized = k;
+  return prev;
 }
 
 inline InstanceKlass* JavaThread::class_being_initialized() const {
+  assert(this == Thread::current(), "Only the current thread can get this field");
   return _class_being_initialized;
 }
 
 inline void JavaThread::om_set_monitor_cache(ObjectMonitor* monitor) {
   assert(UseObjectMonitorTable, "must be");
diff a/src/hotspot/share/runtime/methodDetails.cpp b/src/hotspot/share/runtime/methodDetails.cpp
--- /dev/null
+++ b/src/hotspot/share/runtime/methodDetails.cpp
@@ -0,0 +1,71 @@
+/*
+ * Copyright (c) 1997, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+
+#include "compiler/abstractCompiler.hpp"
+#include "compiler/compileBroker.hpp"
+#include "compiler/disassembler.hpp"
+#include "oops/oop.inline.hpp"
+#include "runtime/interfaceSupport.inline.hpp"
+#include "runtime/methodDetails.hpp"
+
+Symbol* MethodDetails::class_name() {
+  if (_class_name == nullptr) {
+    if (_method_handle != nullptr) {
+      _class_name = (*_method_handle)->method_holder()->name();
+    } else if (_ci_method != nullptr) {
+      _class_name = _ci_method->holder()->name()->get_symbol();
+    } else if (_method != nullptr) {
+      _class_name = _method->method_holder()->name();
+    }
+  }
+  return _class_name;
+}
+
+Symbol* MethodDetails::method_name() {
+  if (_method_name == nullptr) {
+    if (_method_handle != nullptr) {
+      _method_name = (*_method_handle)->name();
+    } else if (_ci_method != nullptr) {
+      _method_name = _ci_method->name()->get_symbol();
+    } else if (_method != nullptr) {
+      _method_name = _method->name();
+    }
+  }
+  return _method_name;
+}
+
+Symbol* MethodDetails::signature() {
+  if (_signature == nullptr) {
+    if (_method_handle != nullptr) {
+      _signature = (*_method_handle)->signature();
+    } else if (_ci_method != nullptr) {
+      _signature = _ci_method->signature()->as_symbol()->get_symbol();
+    } else if (_method != nullptr) {
+      _signature = _method->signature();
+    }
+  }
+  return _signature;
+}
diff a/src/hotspot/share/runtime/methodDetails.hpp b/src/hotspot/share/runtime/methodDetails.hpp
--- /dev/null
+++ b/src/hotspot/share/runtime/methodDetails.hpp
@@ -0,0 +1,70 @@
+/*
+ * Copyright (c) 1997, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_RUNTIME_METHOD_DETAILS_HPP
+#define SHARE_RUNTIME_METHOD_DETAILS_HPP
+
+#include "code/codeBlob.hpp"
+#include "code/vmreg.hpp"
+#include "interpreter/linkResolver.hpp"
+#include "memory/allStatic.hpp"
+#include "memory/resourceArea.hpp"
+#include "utilities/macros.hpp"
+
+class ciMethod;
+
+class MethodDetails: public CHeapObj<mtInternal> {
+private:
+  const methodHandle* _method_handle;
+  const ciMethod* _ci_method;
+  const Method* _method;
+
+  Symbol* _class_name;
+  Symbol* _method_name;
+  Symbol* _signature;
+
+  MethodDetails(const methodHandle* method_handle, const ciMethod* ci_method, const Method* method) :
+    _method_handle(method_handle), _ci_method(ci_method), _method(method),
+    _class_name(nullptr), _method_name(nullptr), _signature(nullptr)
+    {};
+
+public:
+  MethodDetails(const methodHandle& method) :
+    MethodDetails(&method, nullptr, nullptr) {}
+
+  MethodDetails(const methodHandle* method) :
+    MethodDetails(method, nullptr, nullptr) {}
+
+  MethodDetails(const ciMethod* method) :
+    MethodDetails(nullptr, method, nullptr) {}
+
+  MethodDetails(const Method* method) :
+    MethodDetails(nullptr, nullptr, method) {}
+
+  Symbol* class_name();
+  Symbol* method_name();
+  Symbol* signature();
+};
+
+#endif // SHARE_RUNTIME_METHOD_DETAILS_HPP
diff a/src/hotspot/share/runtime/mutex.cpp b/src/hotspot/share/runtime/mutex.cpp
--- a/src/hotspot/share/runtime/mutex.cpp
+++ b/src/hotspot/share/runtime/mutex.cpp
@@ -270,14 +270,15 @@
 Mutex::~Mutex() {
   assert_owner(nullptr);
   os::free(const_cast<char*>(_name));
 }
 
-Mutex::Mutex(Rank rank, const char * name, bool allow_vm_block) : _owner(nullptr) {
+Mutex::Mutex(Rank rank, const char * name, bool allow_vm_block) : _owner(nullptr), _id(-1) {
   assert(os::mutex_init_done(), "Too early!");
   assert(name != nullptr, "Mutex requires a name");
   _name = os::strdup(name, mtInternal);
+  _id = MutexLocker::name2id(name);
 #ifdef ASSERT
   _allow_vm_block  = allow_vm_block;
   _rank            = rank;
   _skip_rank_check = false;
 
diff a/src/hotspot/share/runtime/mutex.hpp b/src/hotspot/share/runtime/mutex.hpp
--- a/src/hotspot/share/runtime/mutex.hpp
+++ b/src/hotspot/share/runtime/mutex.hpp
@@ -96,10 +96,11 @@
   void raw_set_owner(Thread* new_owner) { Atomic::store(&_owner, new_owner); }
 
  protected:                              // Monitor-Mutex metadata
   PlatformMonitor _lock;                 // Native monitor implementation
   const char* _name;                     // Name of mutex/monitor
+  int _id;                               // ID for named mutexes
 
   // Debugging fields for naming, deadlock detection, etc. (some only used in debug mode)
 #ifndef PRODUCT
   bool    _allow_vm_block;
 #endif
@@ -192,10 +193,15 @@
   void set_owner(Thread* owner) { set_owner_implementation(owner); }
   bool owned_by_self() const;
 
   const char *name() const                  { return _name; }
 
+  int      id() const { return _id; }
+//  void set_id(int id) { _id = id; }
+
+  static const char* id2name(int id);
+
   void print_on_error(outputStream* st) const;
   #ifndef PRODUCT
     void print_on(outputStream* st) const;
     void print() const;
   #endif
